<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2004 Ian Berry                                            |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | cacti: a php-based graphing solution                                    |
 +-------------------------------------------------------------------------+
 | Most of this code has been designed, written and is maintained by       |
 | Ian Berry. See about.php for specific developer credit. Any questions   |
 | or comments regarding this code should be directed to:                  |
 | - iberry@raxnet.net                                                     |
 +-------------------------------------------------------------------------+
 | - raXnet - http://www.raxnet.net/                                       |
 +-------------------------------------------------------------------------+
*/

$guest_account = true;
include("./include/auth.php");
include("./include/top_graph_header.php");


/* make sure the graph requested exists (sanity) */
if (!(db_fetch_cell("select local_graph_id from graph_templates_graph where local_graph_id=" . $_GET["local_graph_id"]))) {
	print "<strong><font size='+1' color='FF0000'>GRAPH DOES NOT EXIST</font></strong>"; exit;
}

/* take graph permissions into account here, if the user does not have permission
give an "access denied" message */
if (read_config_option("global_auth") == "on") {
	$access_denied = !(is_graph_allowed($_GET["local_graph_id"]));
	
	if ($access_denied == true) {
		print "<strong><font size='+1' color='FF0000'>ACCESS DENIED</font></strong>"; exit;
	}
}

$graph_title = get_graph_title($_GET["local_graph_id"]);

$rra = db_fetch_row("select timespan,steps from rra where id=" . $_GET["rra_id"]);

/* define the time span, which decides which rra to use */
$timespan = -($rra["timespan"]);
 
/* find the step and how often this graph is updated with new data */
$ds_step = db_fetch_cell("select
                         data_template_data.rrd_step
                         from data_template_data,data_template_rrd,graph_templates_item
                         where graph_templates_item.task_item_id=data_template_rrd.id
                         and data_template_rrd.local_data_id=data_template_data.local_data_id
                         and graph_templates_item.local_graph_id=" . $_GET["local_graph_id"] .
                         "limit 0,1");
$ds_step = empty($ds_step) ? 300 : $ds_step;
$seconds_between_graph_updates = ($ds_step * $rra["steps"]);

$now = time();

$graph_start = isset($_GET["graph_start"]) ? $_GET["graph_start"] : $now + $timespan;
$graph_end = isset($_GET["graph_end"]) ? $_GET["graph_end"] : $now - $seconds_between_graph_updates;
$graph_height = 12;
$graph_width = 50;

        $graph = db_fetch_row("select
                graph_templates_graph.title_cache,
                graph_templates_graph.vertical_label,
                graph_templates_graph.auto_scale,
                graph_templates_graph.auto_scale_opts,
                graph_templates_graph.auto_scale_log,
                graph_templates_graph.auto_scale_rigid,
                graph_templates_graph.auto_padding,
                graph_templates_graph.base_value,
                graph_templates_graph.upper_limit,
                graph_templates_graph.lower_limit,
                graph_templates_graph.height,
                graph_templates_graph.width,
                graph_templates_graph.image_format_id,
                graph_templates_graph.unit_value,
                graph_templates_graph.unit_exponent_value,
                graph_templates_graph.export
                from graph_templates_graph
                where graph_templates_graph.local_graph_id=" . $local_graph_id);

$graph_height = $graph["height"];
$graph_width = $graph["width"];

if ((isset($_GET["type"]) ? $_GET["type"] : "") == "tree") {
	print "<table width='98%' style='background-color: #ffffff; border: 1px solid #ffffff;' align='center' cellpadding='3'>";
}else{
	print "<br><table width='98%' style='background-color: #f5f5f5; border: 1px solid #bbbbbb;' align='center' cellpadding='3'>";
}

print "<tr bgcolor='#" . $colors["header_panel"] . "'><td colspan='3' class='textHeaderDark'><strong>Zooming Graph</strong> '$graph_title'</td></tr>";

print "<tr><td>";

print "<div id='zoomBox' style='position:absolute; overflow:none; left:0px; top:0px; width:0px; height:0px; visibility:visible; background:red; filter:alpha(opacity=50); -moz-opacity:0.5;'></div>\n";
 
print "<div id='zoomSensitiveZone' style='position:absolute; overflow:none; left:0px; top:0px; width:0px; height:0px; visibility:visible; cursor:crosshair; background:blue; filter:alpha(opacity=0); -moz-opacity:0;'></div>\n";
	
print "<div align='center'><img id='zoomGraphImage' src='graph_image.php?local_graph_id=" . $_GET["local_graph_id"] . "&rra_id=" . $_GET["rra_id"] . "&graph_start=" . $graph_start . "&graph_end=" . $graph_end . "&graph_height=" . $graph_height . "&graph_width=" . $graph_width . "' border='0' alt='$graph_title'></div>\n";

print "<div align='center'> [<a href='zoom.php?local_graph_id=" . $_GET["local_graph_id"] . "&rra_id=" . $_GET["rra_id"] . "&graph_start=" . $graph_start . "&graph_end=" . $graph_end . "&graph_height=" . $graph_height . "&graph_width=" . $graph_width . "&show_source=true'>source</a>]</div><br>\n";


print "</td></tr>";
	
print "</table>";
print "<br><br>";

include_once("./include/bottom_footer.php");
include_once("./include/zoom.js");
?>
